#include <gtk2perl.h>
#include <cairo-perl.h>
#include <gtkcairo.h>
#include "gtkcairoperl-autogen.h"
#include <gperl_marshal.h>

static SV *
newSVCairo (cairo_t * cr)
{
	cairo_reference (cr);
	return sv_setref_pv (newSV(0), "Cairo", (void*) cr);
}

static void
gtkcairoperl_paint_marshal (GClosure * closure,
                            GValue * return_value,
                            guint n_param_values,
                            const GValue * param_values,
                            gpointer invocation_hint,
                            gpointer marshal_data)
{
	dGPERL_CLOSURE_MARSHAL_ARGS;

	GPERL_CLOSURE_MARSHAL_INIT (closure, marshal_data);

	ENTER;
	SAVETMPS;
	PUSHMARK (SP);

	GPERL_CLOSURE_MARSHAL_PUSH_INSTANCE (param_values);
	XPUSHs (newSVCairo ((cairo_t*)g_value_get_pointer (param_values+1)));
	GPERL_CLOSURE_MARSHAL_PUSH_DATA;

	PUTBACK;

	GPERL_CLOSURE_MARSHAL_CALL (G_VOID);

	PUTBACK;

	FREETMPS;
	LEAVE;
}

MODULE = Gtk2::Cairo	PACKAGE = Gtk2::Cairo	PREFIX = gtk_cairo_

BOOT:
#include "register.xsh"
	gperl_signal_set_marshaller_for (GTK_TYPE_CAIRO, "paint",
	                                 gtkcairoperl_paint_marshal);


GtkWidget* gtk_cairo_new (class);
    C_ARGS:
	/*void*/

cairo_t* gtk_cairo_get_cairo (GtkCairo *gtkcairo);

##
## convenience function to set the current cairo color
## from a GdkColor
##
void gtk_cairo_set_gdk_color (cairo_t *cr, GdkColor *color);

