use strict;
use warnings;
use ExtUtils::PkgConfig;
use ExtUtils::MakeMaker;
use ExtUtils::Depends;
use Gtk2::CodeGen;

mkdir 'build', 0777;

my %pkgcfg = ExtUtils::PkgConfig->find ('gtkcairo');

Gtk2::CodeGen->parse_maps ('gtkcairoperl');

our $bridge = ExtUtils::Depends->new ('Gtk2::Cairo', 'Gtk2', 'Cairo');
$bridge->set_inc ($pkgcfg{cflags});
$bridge->set_libs ($pkgcfg{libs});
$bridge->add_xs ('Cairo.xs');
$bridge->add_pm ('Cairo.pm' => '$(INST_LIBDIR)/Cairo.pm');
$bridge->add_typemaps (qw(build/gtkcairoperl.typemap));

WriteMakefile (
	NAME => 'Gtk2::Cairo',
	VERSION_FROM => 'Cairo.pm',
	$bridge->get_makefile_vars,
);
